javax.jms

## Interface XAJMSContext

- All Superinterfaces:
    AutoCloseable, JMSContext

      public interface XAJMSContext
      extends JMSContext

  The `XAJMSContext` interface extends the capability of `JMSContext` by adding access to a JMS provider's support for the Java Transaction API (JTA) (optional). This support takes the form of a `javax.transaction.xa.XAResource` object. The functionality of this object closely resembles that defined by the standard X/Open XA Resource interface.

  An application server controls the transactional assignment of an `XASession` by obtaining its `XAResource`. It uses the `XAResource` to assign the session to a transaction, prepare and commit work on the transaction, and so on.

  An `XAResource` provides some fairly sophisticated facilities for interleaving work on multiple transactions, recovering a list of transactions in progress, and so on. A JTA aware JMS provider must fully implement this functionality. This could be done by using the services of a database that supports XA, or a JMS provider may choose to implement this functionality from scratch.

  A client of the application server is given what it thinks is an ordinary `JMSContext`. Behind the scenes, the application server controls the transaction management of the underlying `XAJMSContext`.

  The `XAJMSContext` interface is optional. JMS providers are not required to support this interface. This interface is for use by JMS providers to support transactional environments. Client programs are strongly encouraged to use the transactional support available in their environment, rather than use these XA interfaces directly.

  Since:
    JMS 2.0

- - ### Field Summary

    - ### Fields inherited from interface javax.jms.JMSContext

      `AUTO_ACKNOWLEDGE, CLIENT_ACKNOWLEDGE, DUPS_OK_ACKNOWLEDGE, SESSION_TRANSACTED`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `commit()` Throws a `TransactionInProgressRuntimeException`, since it should not be called for an `XAJMSContext` object.
    `JMSContext` | `getContext()` Returns the `JMSContext` object associated with this `XAJMSContext`.
    `boolean` | `getTransacted()` Returns whether the session is in transacted mode; this method always returns true.
    `XAResource` | `getXAResource()` Returns an `XAResource` to the caller.
    `void` | `rollback()` Throws a `TransactionInProgressRuntimeException`, since it should not be called for an `XAJMSContext` object.

    - ### Methods inherited from interface javax.jms.JMSContext

      `acknowledge, close, createBrowser, createBrowser, createBytesMessage, createConsumer, createConsumer, createConsumer, createContext, createDurableConsumer, createDurableConsumer, createMapMessage, createMessage, createObjectMessage, createObjectMessage, createProducer, createQueue, createSharedConsumer, createSharedConsumer, createSharedDurableConsumer, createSharedDurableConsumer, createStreamMessage, createTemporaryQueue, createTemporaryTopic, createTextMessage, createTextMessage, createTopic, getAutoStart, getClientID, getExceptionListener, getMetaData, getSessionMode, recover, setAutoStart, setClientID, setExceptionListener, start, stop, unsubscribe`

- - ### Method Detail

    - #### getContext

          JMSContext getContext()

      Returns the `JMSContext` object associated with this `XAJMSContext`.
      Returns:
        the `JMSContext` object associated with this `XAJMSContext`

    - #### getXAResource

          XAResource getXAResource()

      Returns an `XAResource` to the caller.
      Returns:
        an `XAResource`

    - #### getTransacted

          boolean getTransacted()

      Returns whether the session is in transacted mode; this method always returns true.
      Specified by:
        `getTransacted` in interface `JMSContext`
      Returns:
        true

    - #### commit

          void commit()

      Throws a `TransactionInProgressRuntimeException`, since it should not be called for an `XAJMSContext` object.
      Specified by:
        `commit` in interface `JMSContext`
      Throws:
        `TransactionInProgressRuntimeException` - if the method is called on an `XAJMSContext`.

    - #### rollback

          void rollback()

      Throws a `TransactionInProgressRuntimeException`, since it should not be called for an `XAJMSContext` object.
      Specified by:
        `rollback` in interface `JMSContext`
      Throws:
        `TransactionInProgressRuntimeException` - if the method is called on an `XAJMSContext`.

Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.